!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine Boundary
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: boundary.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3m-20050810 $
!   * Change History: 
!
!== Overview 
!
!Ϳ뤿Υ⥸塼. 
! type ˻ꤵ줿狼, ֤Τפʬͤꤹ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!ʿľ໤̵Ȥ, ήΥƥȷ׻ѤǤ뤳Ȥ.
!
!== Future Plans
!
                                                                 !=end

subroutine boundary(type, var)
                                                                 !=begin
  !== Dependency
  use dc_trace, only: BeginSub, EndSub
  use dc_message, only: MessageNotify
  use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax, Margin, &
       &             RegXMin, RegXMax, RegZMin, RegZMax
                                                                 !=end  
  !--- ۤηػ
  implicit none
                                                                 !=begin  
  !== Input
  character(*), intent(in)   :: type

  !== In/Out
  real(8), intent(inout)     :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end    
  !--- ѿ
  integer   :: i

   call BeginSub("boundary", &
&                 fmt="%c",       &
&                 c1="Set boundary conditions.")

  if (type == "CC") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do
     
     !--- z :      
     do i = 0, Margin
        var(:, RegZMin - i) = var(:, RegZMax - i) 
     end do
     do i = 1, Margin
        var(:, RegZMax + i) = var(:, RegZMin + i) 
     end do

  elseif (type == "CsS") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do

     !--- z : о
     do i = 0, Margin
        var(:, RegZMin - i) = var(:, RegZMin + 1 + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax + 1 - i )
     end do
     
  elseif (type == "CfS") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do

     !--- z : о
     var(:, RegZMin) = 0.0d0
     var(:, RegZMax) = 0.0d0
     do i = 1, Margin
        var(:, RegZMin - i) = var(:, RegZMin + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax - i )
     end do
     
  elseif (type == "CsA") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do

     !--- z : ȿо     
     do i = 0, Margin
        var(:, RegZMin - i) = - var(:, RegZMin + 1 + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i) = - var(:, RegZMax + 1 - i )
     end do
     
  elseif (type == "CfA") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do
     
     !--- z : ȿо     
     var(:, RegZMin) = 0.0d0
     var(:, RegZMax) = 0.0d0
     do i = 1, Margin
        var(:, RegZMin - i) = - var(:, RegZMin + i )        
    end do
     do i = 1, Margin
        var(:, RegZMax + i) = - var(:, RegZMax - i )
     end do

     
  !--- test     
  elseif (type == "CsAS") then 
     !--- x : 
     do i = 0, Margin
        var(RegXMin - i , RegZMin:RegZMax) &
             & = var(RegXMax - i , RegZMin:RegZMax) 
     end do
     do i = 1, Margin
        var(RegXMax + i , RegZMin:RegZMax) &
             & = var(RegXMin + i , RegZMin:RegZMax) 
     end do

     !--- z : оΤȿо     
     do i = 0, Margin
        var(:, RegZMin - i) = - var(:, RegZMin + 1 + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax + 1 - i )
     end do


  elseif (type == "sSsS") then 
     !--- x : о
     do i = 0, Margin
        var(RegXMin - i,:) = var(RegXMin + 1 + i,: )
     end do
     do i = 1, Margin
        var(RegXMax + i ,:) = var(RegXMax + 1 - i,: )
     end do

     !--- z : о
     do i = 0, Margin
        var(:, RegZMin - i) = var(:, RegZMin + 1 + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax + 1 - i )
     end do
     

  elseif (type == "sSfS") then 
     !--- x : о
     do i = 0, Margin
        var(RegXMin - i,:) = var(RegXMin + 1 + i,: )
     end do
     do i = 1, Margin
        var(RegXMax + i ,:) = var(RegXMax + 1 - i,: )
     end do

     !--- z : о
     var(:,RegZMin) = var(:,RegZMin + 1)

     do i = 1, Margin
        var(:, RegZMin - i) = var(:, RegZMin + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax - i )
     end do

  elseif (type == "fSsS") then 
     !--- x : о
     var(RegXMin,:) = var(RegXMin + 1,:)

     do i = 1, Margin
        var(RegXMin - i,:) = var(RegXMin + i,: )
     end do
     do i = 1, Margin
        var(RegXMax + i ,:) = var(RegXMax - i,: )
     end do

     !--- z : о
     do i = 0, Margin
        var(:, RegZMin - i) = var(:, RegZMin + 1 + i )
     end do
     do i = 1, Margin
        var(:, RegZMax + i ) = var(:, RegZMax + 1 - i )
     end do
     

  else
     call MessageNotify("Error", "boundary", &
&                       "Unknown Boundary Type", c1=type)

  end if

  call EndSub("boundary")

end subroutine boundary
