!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module Linlib
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: linlib.f90.ffc,v 1.2.2.1 2005/08/10 13:20:08 kitamo Exp $ 
!   * Tag Name: $Name: arare3m-20050810 $
!   * Change History: 
!
!== Overview 
!
!׻饤֥ SSL II  LAPACK Υåѡ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module linlib
  implicit none
  
  private
                                                                 !=begin
  !== Public Interface
  public linlib_init       !롼
  public linsolv           ! 3 ϢΩ 1 ()

  integer       :: LN = 10 !Υ. ͤϥߡ
  character(1)  :: LLib    !Ѥ饤֥Υե饰
  real(8), allocatable  ::  A(:)              ! 
  real(8), allocatable  ::  B(:)              ! 
  real(8), allocatable  ::  C(:)              ! 
  real(8), allocatable  ::  B2(:)             ! (LU ʬ)
  real(8), allocatable  ::  ss_F1BasicZ(:,:)  ! η׻Ѥ
  real(8), allocatable  ::  sf_F2BasicZ(:,:)  ! η׻Ѥ
  real(8), allocatable  ::  IPIV(:)           ! 

  save LLib, LN, A, B, C, B2, ss_F1BasicZ, sf_F2BasicZ, IPIV
                                                                 !=end    
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !Ѥ׻ѥå NAMELIST ꤷ, 
  !礭ꤹ
  !
  subroutine linlib_init(cfgfile, N)

    !=== Dependency
    use dc_trace, only : BeginSub, EndSub
    use dc_message, only: MessageNotify
    use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax, &
         &              RegXMax, RegXMin, RegZMin, RegZMax, DelZ
    use timeset,  only: DelTimeShort
    use basicset, only: ss_VelSoundBasicZ, ss_CpBasicZ, &
         &              ss_DensBasicZ, ss_PotTempBasicZ
    use arareset, only: beta
    use ssl2_linear, only: ssl2_ltx_init
    use lapack_linear, only: lapack_dgtsv_init, lapack_dgttrf
    use average, only : sf_avr_ss

    !=== Input
    integer, intent(in)      :: N       !󥵥
    character(*), intent(in) :: cfgfile !ե (NAMELIST)
    
    !=== NAMELIST
    NAMELIST /linlib/ LLib
                                                                 !=end
    open (10, FILE=cfgfile)
    read(10, NML=linlib)
    close(10)

    call BeginSub("linlib_init", &
&                 fmt="%c",       &
&                 c1="Initialize linear algebra library.")

    !--- 󥵥ݴ
    LN = N

    !--- γդ
	allocate(  &
	& A(RegZMin+1:RegZMax),   &
	& B(RegZMin+2:RegZMax),   &  
	& C(RegZMin+1:RegZMax-1), &  
        & B2(RegZMin+3:RegZMax),  &
	& ss_F1BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &  
	& sf_F2BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
	& IPIV(RegZMin+1:RegZMax) )

    !--- Ѥ饤֥ν
    if (LLib == 's') then 
       call MessageNotify("Message", "linlib.f90", &
&                         "Call SSL II in the calculation")

       call ssl2_ltx_init(LN)

    elseif (LLib == 'l') then 
       call MessageNotify("Message", "linlib.f90", &
&                         "Call LAPACK in the calculation")

       call lapack_dgtsv_init(LN)

    else
      call MessageNotify("Error", "linlib.f90", &
&                        "Unknown LLib ", c1=LLib)
    end if

    !--- η׻

    ss_F1BasicZ = ( ss_VelSoundBasicZ ** 2.0d0 ) &
       &        / (ss_CpBasicZ * ss_DensBasicZ *(ss_PotTempBasicZ ** 2.0d0))

    sf_F2BasicZ = sf_avr_ss( &
         & ss_CpBasicZ * ss_DensBasicZ * (ss_PotTempBasicZ ** 2.0d0) )

    A(RegZMin+2: RegZMax-1) = &
         & 1.0d0 + (beta ** 2.0d0) &
         &   * ss_F1BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &  
         &   * ( sf_F2BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &
         &       +  sf_F2BasicZ(RegXMax, RegZMin+1: RegZMax-2) ) &
         &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
  
    A(RegZMin+1) = 1.0d0 &
         & + (beta ** 2.0d0) &
         &   * ss_F1BasicZ(RegXMax, RegZMin+1)  &
         &   * sf_F2BasicZ(RegXMax, RegZMin+1) &
         &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)

    A(RegZMax) = 1.0d0 &
         & + (beta ** 2.0d0) &
         &   * ss_F1BasicZ(RegXMax, RegZMax)  &
         &   * sf_F2BasicZ(RegXMax, RegZMax-1) &
         &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
  
    B(RegZMin+2: RegZMax) = &
         & - ( beta ** 2.0d0 ) &
         &   * ss_F1BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
         &   * sf_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
         &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )
  
    C(RegZMin+1: RegZMax-1) = &
         & - ( beta ** 2.0d0 ) &
         &   * ss_F1BasicZ(RegXMax, RegZMin+2: RegZMax) &
         &   * sf_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
         &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )

    !---  LU ʬ (LAPACK)
    if (LLib == 'l') then
       call lapack_dgttrf(A, B, C, B2, IPIV)
    endif

    call EndSub("linlib_init")

  end subroutine linlib_init
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !Ѥ׻ѥåϤ
  !
  subroutine LinSolv(D)

    !=== Dependency
    use dc_trace, only : BeginSub, EndSub
    use dc_message, only: MessageNotify
    use ssl2_linear, only: ssl2_ltx
    use lapack_linear, only: lapack_dgttrs

    !=== In/Out
    real(8), intent(inout) :: D(LN)
                                                                 !=end

    !=== Work
    real(8)                :: AA(LN)
    real(8)                :: BB(LN-1)
    real(8)                :: CC(LN-1) 

    call BeginSub("linsolv", &
&                 fmt="%c",       &
&                 c1="call linear algebra library.")

    !--- ϢΩ 1 
    if (LLib == 's') then 
       call ssl2_ltx(A, B, C, D)

    elseif (LLib == 'l') then 
       !=== ° inout ʤΤ, ѿȤȤ.
       AA = A; BB = B; CC = C
       call lapack_dgttrs(AA, BB, CC, D, B2, IPIV)
       
    else
      call MessageNotify("Error", "linlib", &
&                        "unknown LLib")
    end if

    call EndSub("linsolv")

  end subroutine LinSolv
  
end module linlib
