!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module SSL2_Linear
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: ssl2_linear.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name: arare3m-20050810 $
!   * Change History: 
!
!== Overview 
!
!SSL2 ׻ΤΥѥå⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!顼 gt4f90io Ȥ
!
                                                                 !=end

module ssl2_linear
  implicit none
  
  private
                                                                 !=begin
  !=== Public Interface
  public ssl2_lax_init       !
  public ssl2_lax            !¹ϢΩ 1 ()
  public ssl2_lsx_init       !
  public ssl2_lsx            !оιϢΩ 1 ()
  public ssl2_lsix_init      !
  public ssl2_lsix           !оιϢΩ 1 ()
  public ssl2_ltx_init       !
  public ssl2_ltx            ! 3 ϢΩ 1 ()
                                                                 !=end
  real(8), allocatable      :: VW(:)  
  real(8)                   :: EPSZ = 0.0d0 ! ɸ
  integer, allocatable      :: IP(:)
  integer, allocatable      :: IVW(:)
  integer                   :: ISW = 1
  integer                   :: K = 10       !ͤϥߡ
  integer                   :: N = 10       !ͤϥߡ

  save K, N, ISW, IP, EPSZ, VW, IVW

contains

                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module 
  !
  !SSL II  LAX 롼ν
  !
  subroutine ssl2_lax_init(M)

    !=== Input
    integer, intent(in) :: M  !礭
                                                                 !=end
    if (allocated(IP)) deallocate(IP, VW)
    allocate(IP(M), VW(M))
    N = M
    K = M
  end subroutine ssl2_lax_init
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  !¹ϢΩ 1 ()
  !
  subroutine ssl2_lax(A, B, sw)

    !=== In/Out
    real(8), intent(inout)         :: A(:,:)     !
    real(8), intent(inout)         :: B(:)       !/

    !=== Output
    logical, intent(out), optional :: sw         !§ɽå
                                                                 !=end
    integer                        :: ICON
    integer                        :: IS

    IS = 0; VW = 0.0d0; IP = 0; ICON = 0
    if (present(sw)) sw = .false.

    !礭å
    if (N /= size(B,1) .OR. N /= size(A,1) .OR. N /= size(A,2)) then  
       write(*,*) "ssl2_lax; matrix size is wrong"
       stop
    end if

    !η׻. SSL II . 
    call DLAX(A, K, N, B, EPSZ, ISW, IS, VW, IP, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lax: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lax: ICON is 20000' 
       write(*,*) "ssl2_lax: matrix is singular!"
       if (present(sw)) then           
          sw = .true.
       else
          stop
       end if
    end if
  end subroutine ssl2_lax

    
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !SSL II  LSX 롼ν
  !
  subroutine ssl2_lsx_init(M)
    !=== Input
    integer, intent(in) :: M   !礭
                                                                 !=end
    N = M
  end subroutine ssl2_lsx_init
  

                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  !оιϢΩ 1 ()
  !
  subroutine ssl2_lsx(A, B, sw)
    real(8), intent(inout)         :: A(:)   !
    real(8), intent(inout)         :: B(:)   !/
    logical, intent(out), optional :: sw     !§ɽå
                                                                 !=end
    integer                        :: ICON

    ICON = 0
    if (present(sw)) sw = .false.

    !礭å
    if (N /= size(B,1) .OR. N*(N+1)/2 /= size(A,1)) then 
       write(*,*) "ssl2_lsx; matrix size is wrong"
    end if

    !η׻. SSL II . 
    call DLSX(A, N, B, EPSZ, ISW, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lsx: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lsx: ICON is 20000' 
       write(*,*) "ssl2_lsx: matrix is singular!"
       if (present(sw)) then           
          sw = .true.
       else
          stop
       end if
    end if
  end subroutine ssl2_lsx
      
    
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !SSL II  LSIX 롼ν
  !
  subroutine ssl2_lsix_init(M)

    !=== Input
    integer, intent(in) :: M    !礭
                                                                 !=end
    if (allocated(IP)) deallocate(IP, VW, IVW)
    allocate(IP(M), VW(2*M), IVW(M))
    N = M
    K = M
  end subroutine ssl2_lsix_init


                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  !оιϢΩ 1 ()
  !
  subroutine ssl2_lsix(A, B, sw)

    !=== In/Out
    real(8), intent(inout)         :: A(:)   !
    real(8), intent(inout)         :: B(:)   !/
    !=== Output
    logical, intent(out), optional :: sw     !§ɽå
                                                                 !=end
    integer                        :: ICON
    
    ICON = 0; VW = 0.0d0; IP = 0; IVW = 0
    if (present(sw)) sw = .false.

    !礭å
    if (N /= size(B,1) .OR. N*(N+1)/2 /= size(A,1)) then 
       write(*,*) "ssl2_lsx; matrix size is wrong"
    end if

    !η׻. SSL II . 
    call DLSIX(A, N, B, EPSZ, ISW, VW, IP, IVW, ICON)
  
    !Υǥå. 
    if (ICON == 30000) then
       write(*,*) 'ssl2_lsix: ICON is 30000' 
       stop
    elseif (ICON == 20000) then
       write(*,*) 'ssl2_lsix: ICON is 20000' 
       write(*,*) "ssl2_lsix: matrix is singular!"
       if (present(sw)) then           
          sw = .true.
       else
          stop
       end if
    end if
    
  end subroutine ssl2_lsix
  

                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !SSL II  LTX 롼ν
  !
  subroutine ssl2_ltx_init(M)

    !=== Input
    integer, intent(in) :: M  !礭
                                                                 !=end
    if (allocated(IP)) deallocate(IP, VW)
    allocate(IP(M), VW(M))
    N = M
  end subroutine ssl2_ltx_init
  
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  ! 3 ϢΩ 1 ()
  !
  subroutine ssl2_ltx(A, B, C, D)
    !=== Dependency
    use dc_message, only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none
                                                                 !=begin
    !=== Input
    real(8), intent(in)            :: A(N)      !
    real(8), intent(in)            :: B(N-1)    !
    real(8), intent(in)            :: C(N-1)    !

    !=== In/Out
    real(8), intent(inout)         :: D(N)      !/
                                                                 !=end
    !=== Work
    integer                        :: ICON
    integer                        :: IS
    
    ICON = 0; VW = 0.0d0; IP = 0
    
    !=== η׻. SSL II . 
    call DLTX(C, A, B, N, D, EPSZ, ISW, IS, IP, VW, ICON)
    
    !=== Υǥå. 
    if (ICON == 30000) then
       call MessageNotify("Error", "ssl2_linear", &
&                        "ICON is 30000. matrix is singular!!")
       stop
    elseif (ICON == 20000) then
       call MessageNotify("Error", "ssl2_linear", &
&                        "ICON is 20000. matrix is singular!!")
       stop
    end if
    
  end subroutine ssl2_ltx
  
    
end module ssl2_linear
